# FlespiGatewayRestApi.CommandsqueueApi

All URIs are relative to *https://flespi.io/gw*

Method | HTTP request | Description
------------- | ------------- | -------------
[**channelsChSelectorCommandsQueueCmdQueueSelectorDelete**](CommandsqueueApi.md#channelsChSelectorCommandsQueueCmdQueueSelectorDelete) | **DELETE** /channels/{ch-selector}/commands-queue/{cmd-queue-selector} | Remove commands from queue 
[**channelsChSelectorCommandsQueueCmdQueueSelectorGet**](CommandsqueueApi.md#channelsChSelectorCommandsQueueCmdQueueSelectorGet) | **GET** /channels/{ch-selector}/commands-queue/{cmd-queue-selector} | Get commands from the queue 
[**channelsChSelectorCommandsQueueCmdQueueSelectorPut**](CommandsqueueApi.md#channelsChSelectorCommandsQueueCmdQueueSelectorPut) | **PUT** /channels/{ch-selector}/commands-queue/{cmd-queue-selector} | Change command&#39;s fields 
[**channelsChSelectorCommandsQueuePost**](CommandsqueueApi.md#channelsChSelectorCommandsQueuePost) | **POST** /channels/{ch-selector}/commands-queue | Add command to commands buffer 


<a name="channelsChSelectorCommandsQueueCmdQueueSelectorDelete"></a>
# **channelsChSelectorCommandsQueueCmdQueueSelectorDelete**
> InlineResponse2003 channelsChSelectorCommandsQueueCmdQueueSelectorDelete(chSelectorcmdQueueSelector)

Remove commands from queue 

Delete commands meeting filtering conditions for specified channels. 

### Example
```javascript
var FlespiGatewayRestApi = require('flespi_gateway_rest_api');
var defaultClient = FlespiGatewayRestApi.ApiClient.default;

// Configure API key authorization: FlespiToken
var FlespiToken = defaultClient.authentications['FlespiToken'];
FlespiToken.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//FlespiToken.apiKeyPrefix = 'Token';

var apiInstance = new FlespiGatewayRestApi.CommandsqueueApi();

var chSelector = ["chSelector_example"]; // [String] | Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name=mask -name matches wildcard mask   - uri=mask - URI matches wildcard mask   - protocol_id=value - channel's protocol ID matches value   - protocol_name=mask - protocol's name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled=true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled=true,protocol_id=10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled=false | inactive channels from the list of channels with IDs 1,2,3 

var cmdQueueSelector = ["cmdQueueSelector_example"]; // [String] | Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - ident=mask - connected device identification string matches wildcard mask   - executed=true/false - flag that command have been already executed   Request example | Description --------- | --------   /channels/all/commands/all | all created commands on all channels   /channels/1,2,3/commands/all | all created commands on channels 1,2,3   /channels/all/commands/executed=true | all executed commands on all channels 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.channelsChSelectorCommandsQueueCmdQueueSelectorDelete(chSelectorcmdQueueSelector, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **chSelector** | [**[String]**](String.md)| Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name&#x3D;mask -name matches wildcard mask   - uri&#x3D;mask - URI matches wildcard mask   - protocol_id&#x3D;value - channel&#39;s protocol ID matches value   - protocol_name&#x3D;mask - protocol&#39;s name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled&#x3D;true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled&#x3D;true,protocol_id&#x3D;10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled&#x3D;false | inactive channels from the list of channels with IDs 1,2,3  | 
 **cmdQueueSelector** | [**[String]**](String.md)| Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - ident&#x3D;mask - connected device identification string matches wildcard mask   - executed&#x3D;true/false - flag that command have been already executed   Request example | Description --------- | --------   /channels/all/commands/all | all created commands on all channels   /channels/1,2,3/commands/all | all created commands on channels 1,2,3   /channels/all/commands/executed&#x3D;true | all executed commands on all channels  | 

### Return type

[**InlineResponse2003**](InlineResponse2003.md)

### Authorization

[FlespiToken](../README.md#FlespiToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="channelsChSelectorCommandsQueueCmdQueueSelectorGet"></a>
# **channelsChSelectorCommandsQueueCmdQueueSelectorGet**
> InlineResponse2003 channelsChSelectorCommandsQueueCmdQueueSelectorGet(chSelectorcmdQueueSelector, opts)

Get commands from the queue 

Get commands waiting to be sent meeting filtering conditions. 

### Example
```javascript
var FlespiGatewayRestApi = require('flespi_gateway_rest_api');
var defaultClient = FlespiGatewayRestApi.ApiClient.default;

// Configure API key authorization: FlespiToken
var FlespiToken = defaultClient.authentications['FlespiToken'];
FlespiToken.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//FlespiToken.apiKeyPrefix = 'Token';

var apiInstance = new FlespiGatewayRestApi.CommandsqueueApi();

var chSelector = ["chSelector_example"]; // [String] | Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name=mask -name matches wildcard mask   - uri=mask - URI matches wildcard mask   - protocol_id=value - channel's protocol ID matches value   - protocol_name=mask - protocol's name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled=true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled=true,protocol_id=10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled=false | inactive channels from the list of channels with IDs 1,2,3 

var cmdQueueSelector = ["cmdQueueSelector_example"]; // [String] | Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - ident=mask - connected device identification string matches wildcard mask   - executed=true/false - flag that command have been already executed   Request example | Description --------- | --------   /channels/all/commands/all | all created commands on all channels   /channels/1,2,3/commands/all | all created commands on channels 1,2,3   /channels/all/commands/executed=true | all executed commands on all channels 

var opts = { 
  'fields': ["fields_example"] // [String] | CSV-formatted list of JSON object fields to be returned in reply collection. 
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.channelsChSelectorCommandsQueueCmdQueueSelectorGet(chSelectorcmdQueueSelector, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **chSelector** | [**[String]**](String.md)| Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name&#x3D;mask -name matches wildcard mask   - uri&#x3D;mask - URI matches wildcard mask   - protocol_id&#x3D;value - channel&#39;s protocol ID matches value   - protocol_name&#x3D;mask - protocol&#39;s name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled&#x3D;true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled&#x3D;true,protocol_id&#x3D;10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled&#x3D;false | inactive channels from the list of channels with IDs 1,2,3  | 
 **cmdQueueSelector** | [**[String]**](String.md)| Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - ident&#x3D;mask - connected device identification string matches wildcard mask   - executed&#x3D;true/false - flag that command have been already executed   Request example | Description --------- | --------   /channels/all/commands/all | all created commands on all channels   /channels/1,2,3/commands/all | all created commands on channels 1,2,3   /channels/all/commands/executed&#x3D;true | all executed commands on all channels  | 
 **fields** | [**[String]**](String.md)| CSV-formatted list of JSON object fields to be returned in reply collection.  | [optional] 

### Return type

[**InlineResponse2003**](InlineResponse2003.md)

### Authorization

[FlespiToken](../README.md#FlespiToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="channelsChSelectorCommandsQueueCmdQueueSelectorPut"></a>
# **channelsChSelectorCommandsQueueCmdQueueSelectorPut**
> InlineResponse2003 channelsChSelectorCommandsQueueCmdQueueSelectorPut(chSelectorcmdQueueSelectordata, opts)

Change command&#39;s fields 

Make changes in commands fields. Apply to commands meeting filtering conditions. 

### Example
```javascript
var FlespiGatewayRestApi = require('flespi_gateway_rest_api');
var defaultClient = FlespiGatewayRestApi.ApiClient.default;

// Configure API key authorization: FlespiToken
var FlespiToken = defaultClient.authentications['FlespiToken'];
FlespiToken.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//FlespiToken.apiKeyPrefix = 'Token';

var apiInstance = new FlespiGatewayRestApi.CommandsqueueApi();

var chSelector = ["chSelector_example"]; // [String] | Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name=mask -name matches wildcard mask   - uri=mask - URI matches wildcard mask   - protocol_id=value - channel's protocol ID matches value   - protocol_name=mask - protocol's name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled=true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled=true,protocol_id=10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled=false | inactive channels from the list of channels with IDs 1,2,3 

var cmdQueueSelector = ["cmdQueueSelector_example"]; // [String] | Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - ident=mask - connected device identification string matches wildcard mask   - executed=true/false - flag that command have been already executed   Request example | Description --------- | --------   /channels/all/commands/all | all created commands on all channels   /channels/1,2,3/commands/all | all created commands on channels 1,2,3   /channels/all/commands/executed=true | all executed commands on all channels 

var data = new FlespiGatewayRestApi.ChannelCommandQueuePut(); // ChannelCommandQueuePut | 

var opts = { 
  'fields': ["fields_example"] // [String] | CSV-formatted list of JSON object fields to be returned in reply collection. 
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.channelsChSelectorCommandsQueueCmdQueueSelectorPut(chSelectorcmdQueueSelectordata, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **chSelector** | [**[String]**](String.md)| Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name&#x3D;mask -name matches wildcard mask   - uri&#x3D;mask - URI matches wildcard mask   - protocol_id&#x3D;value - channel&#39;s protocol ID matches value   - protocol_name&#x3D;mask - protocol&#39;s name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled&#x3D;true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled&#x3D;true,protocol_id&#x3D;10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled&#x3D;false | inactive channels from the list of channels with IDs 1,2,3  | 
 **cmdQueueSelector** | [**[String]**](String.md)| Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - ident&#x3D;mask - connected device identification string matches wildcard mask   - executed&#x3D;true/false - flag that command have been already executed   Request example | Description --------- | --------   /channels/all/commands/all | all created commands on all channels   /channels/1,2,3/commands/all | all created commands on channels 1,2,3   /channels/all/commands/executed&#x3D;true | all executed commands on all channels  | 
 **data** | [**ChannelCommandQueuePut**](ChannelCommandQueuePut.md)|  | 
 **fields** | [**[String]**](String.md)| CSV-formatted list of JSON object fields to be returned in reply collection.  | [optional] 

### Return type

[**InlineResponse2003**](InlineResponse2003.md)

### Authorization

[FlespiToken](../README.md#FlespiToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="channelsChSelectorCommandsQueuePost"></a>
# **channelsChSelectorCommandsQueuePost**
> InlineResponse2003 channelsChSelectorCommandsQueuePost(chSelectordata, opts)

Add command to commands buffer 

Add command to commands queue. Command would be delivered to the device with coresponding ident as soon as there will be established connection from it to the channel. The command to given **ident** would be added for every channel specified by **{ch-selector}**. 

### Example
```javascript
var FlespiGatewayRestApi = require('flespi_gateway_rest_api');
var defaultClient = FlespiGatewayRestApi.ApiClient.default;

// Configure API key authorization: FlespiToken
var FlespiToken = defaultClient.authentications['FlespiToken'];
FlespiToken.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//FlespiToken.apiKeyPrefix = 'Token';

var apiInstance = new FlespiGatewayRestApi.CommandsqueueApi();

var chSelector = ["chSelector_example"]; // [String] | Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name=mask -name matches wildcard mask   - uri=mask - URI matches wildcard mask   - protocol_id=value - channel's protocol ID matches value   - protocol_name=mask - protocol's name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled=true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled=true,protocol_id=10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled=false | inactive channels from the list of channels with IDs 1,2,3 

var data = [new FlespiGatewayRestApi.ChannelCommandsQueuePost()]; // [ChannelCommandsQueuePost] | 

var opts = { 
  'fields': ["fields_example"] // [String] | CSV-formatted list of JSON object fields to be returned in reply collection. 
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.channelsChSelectorCommandsQueuePost(chSelectordata, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **chSelector** | [**[String]**](String.md)| Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name&#x3D;mask -name matches wildcard mask   - uri&#x3D;mask - URI matches wildcard mask   - protocol_id&#x3D;value - channel&#39;s protocol ID matches value   - protocol_name&#x3D;mask - protocol&#39;s name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled&#x3D;true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled&#x3D;true,protocol_id&#x3D;10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled&#x3D;false | inactive channels from the list of channels with IDs 1,2,3  | 
 **data** | [**[ChannelCommandsQueuePost]**](ChannelCommandsQueuePost.md)|  | 
 **fields** | [**[String]**](String.md)| CSV-formatted list of JSON object fields to be returned in reply collection.  | [optional] 

### Return type

[**InlineResponse2003**](InlineResponse2003.md)

### Authorization

[FlespiToken](../README.md#FlespiToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

