# FlespiGatewayRestApi.CommandsresultApi

All URIs are relative to *https://flespi.io/gw*

Method | HTTP request | Description
------------- | ------------- | -------------
[**channelsChSelectorCommandsResultDelete**](CommandsresultApi.md#channelsChSelectorCommandsResultDelete) | **DELETE** /channels/{ch-selector}/commands-result | 
[**channelsChSelectorCommandsResultGet**](CommandsresultApi.md#channelsChSelectorCommandsResultGet) | **GET** /channels/{ch-selector}/commands-result | 


<a name="channelsChSelectorCommandsResultDelete"></a>
# **channelsChSelectorCommandsResultDelete**
> InlineResponse2002 channelsChSelectorCommandsResultDelete(chSelectordata)



Free finished commands until **delete_key** parameter. **delete_key** value may be taken from **last_key** value of previous GET commands-result request. This request is optional, normal method of work is to delete messages via GET /channels/.../commands-result request with **delete**&#x3D;true and valid **curr_key** from previous response.

### Example
```javascript
var FlespiGatewayRestApi = require('flespi_gateway_rest_api');
var defaultClient = FlespiGatewayRestApi.ApiClient.default;

// Configure API key authorization: FlespiToken
var FlespiToken = defaultClient.authentications['FlespiToken'];
FlespiToken.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//FlespiToken.apiKeyPrefix = 'Token';

var apiInstance = new FlespiGatewayRestApi.CommandsresultApi();

var chSelector = ["chSelector_example"]; // [String] | Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name=mask -name matches wildcard mask   - uri=mask - URI matches wildcard mask   - protocol_id=value - channel's protocol ID matches value   - protocol_name=mask - protocol's name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled=true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled=true,protocol_id=10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled=false | inactive channels from the list of channels with IDs 1,2,3 

var data = new FlespiGatewayRestApi.Data1(); // Data1 | Parameters to delete already processed finished commands.


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.channelsChSelectorCommandsResultDelete(chSelectordata, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **chSelector** | [**[String]**](String.md)| Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name&#x3D;mask -name matches wildcard mask   - uri&#x3D;mask - URI matches wildcard mask   - protocol_id&#x3D;value - channel&#39;s protocol ID matches value   - protocol_name&#x3D;mask - protocol&#39;s name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled&#x3D;true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled&#x3D;true,protocol_id&#x3D;10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled&#x3D;false | inactive channels from the list of channels with IDs 1,2,3  | 
 **data** | [**Data1**](Data1.md)| Parameters to delete already processed finished commands. | 

### Return type

[**InlineResponse2002**](InlineResponse2002.md)

### Authorization

[FlespiToken](../README.md#FlespiToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="channelsChSelectorCommandsResultGet"></a>
# **channelsChSelectorCommandsResultGet**
> InlineResponse2004 channelsChSelectorCommandsResultGet(chSelector, opts)



Get executed or expired commands from specified channels. Request features: * Push mode: server will process request as soon as finished commands appear in the channel (or **timeout** expired) * It is assumed that only one handler has a possibility to delete commands. * If **delete** parameter is set and **curr_key** parameter is not empty all the commands up to specified **curr_key** are marked as read and processed.  Designated method of messages consumption is to use GET /channels/.../commands-result request with **timeout**&#x3D;XX (plus some optional limits) and **delete**&#x3D;true and valid **curr_key** from previous response. This will fetch only new executed or expired commands and automatically delete command instances received in previous request. Timeout parameter is wise to use when we need to wait until any new message will arrive to the channel and return then in immediately in response. 

### Example
```javascript
var FlespiGatewayRestApi = require('flespi_gateway_rest_api');
var defaultClient = FlespiGatewayRestApi.ApiClient.default;

// Configure API key authorization: FlespiToken
var FlespiToken = defaultClient.authentications['FlespiToken'];
FlespiToken.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//FlespiToken.apiKeyPrefix = 'Token';

var apiInstance = new FlespiGatewayRestApi.CommandsresultApi();

var chSelector = ["chSelector_example"]; // [String] | Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name=mask -name matches wildcard mask   - uri=mask - URI matches wildcard mask   - protocol_id=value - channel's protocol ID matches value   - protocol_name=mask - protocol's name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled=true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled=true,protocol_id=10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled=false | inactive channels from the list of channels with IDs 1,2,3 

var opts = { 
  'data': "data_example" // String | These parameters are used to receive finished commands and delete processed instances.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.channelsChSelectorCommandsResultGet(chSelector, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **chSelector** | [**[String]**](String.md)| Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name&#x3D;mask -name matches wildcard mask   - uri&#x3D;mask - URI matches wildcard mask   - protocol_id&#x3D;value - channel&#39;s protocol ID matches value   - protocol_name&#x3D;mask - protocol&#39;s name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled&#x3D;true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled&#x3D;true,protocol_id&#x3D;10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled&#x3D;false | inactive channels from the list of channels with IDs 1,2,3  | 
 **data** | **String**| These parameters are used to receive finished commands and delete processed instances. | [optional] 

### Return type

[**InlineResponse2004**](InlineResponse2004.md)

### Authorization

[FlespiToken](../README.md#FlespiToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

