# FlespiGatewayRestApi.ConnectionsApi

All URIs are relative to *https://flespi.io/gw*

Method | HTTP request | Description
------------- | ------------- | -------------
[**channelsChSelectorConnectionsConnSelectorDelete**](ConnectionsApi.md#channelsChSelectorConnectionsConnSelectorDelete) | **DELETE** /channels/{ch-selector}/connections/{conn-selector} | Close TCP connections 
[**channelsChSelectorConnectionsConnSelectorGet**](ConnectionsApi.md#channelsChSelectorConnectionsConnSelectorGet) | **GET** /channels/{ch-selector}/connections/{conn-selector} | List active TCP connections 


<a name="channelsChSelectorConnectionsConnSelectorDelete"></a>
# **channelsChSelectorConnectionsConnSelectorDelete**
> InlineResponse2006 channelsChSelectorConnectionsConnSelectorDelete(chSelectorconnSelector)

Close TCP connections 

Close selected TCP connections to selected channels. 

### Example
```javascript
var FlespiGatewayRestApi = require('flespi_gateway_rest_api');
var defaultClient = FlespiGatewayRestApi.ApiClient.default;

// Configure API key authorization: FlespiToken
var FlespiToken = defaultClient.authentications['FlespiToken'];
FlespiToken.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//FlespiToken.apiKeyPrefix = 'Token';

var apiInstance = new FlespiGatewayRestApi.ConnectionsApi();

var chSelector = ["chSelector_example"]; // [String] | Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name=mask -name matches wildcard mask   - uri=mask - URI matches wildcard mask   - protocol_id=value - channel's protocol ID matches value   - protocol_name=mask - protocol's name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled=true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled=true,protocol_id=10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled=false | inactive channels from the list of channels with IDs 1,2,3 

var connSelector = ["connSelector_example"]; // [String] | Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - ident=mask - connected device identification string matches wildcard mask   - ip=mask - incoming connection IP address matches wildcard mask   - established⋚value - UNIX timestamp of connection opening is greater or smaller then value  Request example | Description --------- | --------   /channels/all/connections/all | all active TCP connections to all channels   /channels/1,2,3/connections/all | all active TCP connections to channels 1,2,3   /channels/all/connections/ip=127.0.\\*.\\*,all active TCP connections to all channels, from given IP address established after Fri Dec 23 2016 08:52:43 GMT+0300 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.channelsChSelectorConnectionsConnSelectorDelete(chSelectorconnSelector, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **chSelector** | [**[String]**](String.md)| Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name&#x3D;mask -name matches wildcard mask   - uri&#x3D;mask - URI matches wildcard mask   - protocol_id&#x3D;value - channel&#39;s protocol ID matches value   - protocol_name&#x3D;mask - protocol&#39;s name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled&#x3D;true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled&#x3D;true,protocol_id&#x3D;10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled&#x3D;false | inactive channels from the list of channels with IDs 1,2,3  | 
 **connSelector** | [**[String]**](String.md)| Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - ident&#x3D;mask - connected device identification string matches wildcard mask   - ip&#x3D;mask - incoming connection IP address matches wildcard mask   - established⋚value - UNIX timestamp of connection opening is greater or smaller then value  Request example | Description --------- | --------   /channels/all/connections/all | all active TCP connections to all channels   /channels/1,2,3/connections/all | all active TCP connections to channels 1,2,3   /channels/all/connections/ip&#x3D;127.0.\\*.\\*,all active TCP connections to all channels, from given IP address established after Fri Dec 23 2016 08:52:43 GMT+0300  | 

### Return type

[**InlineResponse2006**](InlineResponse2006.md)

### Authorization

[FlespiToken](../README.md#FlespiToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="channelsChSelectorConnectionsConnSelectorGet"></a>
# **channelsChSelectorConnectionsConnSelectorGet**
> InlineResponse2005 channelsChSelectorConnectionsConnSelectorGet(chSelectorconnSelector, opts)

List active TCP connections 

List active TCP connections matchnig filtering parameters to selected channels. 

### Example
```javascript
var FlespiGatewayRestApi = require('flespi_gateway_rest_api');
var defaultClient = FlespiGatewayRestApi.ApiClient.default;

// Configure API key authorization: FlespiToken
var FlespiToken = defaultClient.authentications['FlespiToken'];
FlespiToken.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//FlespiToken.apiKeyPrefix = 'Token';

var apiInstance = new FlespiGatewayRestApi.ConnectionsApi();

var chSelector = ["chSelector_example"]; // [String] | Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name=mask -name matches wildcard mask   - uri=mask - URI matches wildcard mask   - protocol_id=value - channel's protocol ID matches value   - protocol_name=mask - protocol's name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled=true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled=true,protocol_id=10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled=false | inactive channels from the list of channels with IDs 1,2,3 

var connSelector = ["connSelector_example"]; // [String] | Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - ident=mask - connected device identification string matches wildcard mask   - ip=mask - incoming connection IP address matches wildcard mask   - established⋚value - UNIX timestamp of connection opening is greater or smaller then value  Request example | Description --------- | --------   /channels/all/connections/all | all active TCP connections to all channels   /channels/1,2,3/connections/all | all active TCP connections to channels 1,2,3   /channels/all/connections/ip=127.0.\\*.\\*,all active TCP connections to all channels, from given IP address established after Fri Dec 23 2016 08:52:43 GMT+0300 

var opts = { 
  'fields': ["fields_example"] // [String] | CSV-formatted list of JSON object fields to be returned in reply collection. 
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.channelsChSelectorConnectionsConnSelectorGet(chSelectorconnSelector, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **chSelector** | [**[String]**](String.md)| Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name&#x3D;mask -name matches wildcard mask   - uri&#x3D;mask - URI matches wildcard mask   - protocol_id&#x3D;value - channel&#39;s protocol ID matches value   - protocol_name&#x3D;mask - protocol&#39;s name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled&#x3D;true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled&#x3D;true,protocol_id&#x3D;10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled&#x3D;false | inactive channels from the list of channels with IDs 1,2,3  | 
 **connSelector** | [**[String]**](String.md)| Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - ident&#x3D;mask - connected device identification string matches wildcard mask   - ip&#x3D;mask - incoming connection IP address matches wildcard mask   - established⋚value - UNIX timestamp of connection opening is greater or smaller then value  Request example | Description --------- | --------   /channels/all/connections/all | all active TCP connections to all channels   /channels/1,2,3/connections/all | all active TCP connections to channels 1,2,3   /channels/all/connections/ip&#x3D;127.0.\\*.\\*,all active TCP connections to all channels, from given IP address established after Fri Dec 23 2016 08:52:43 GMT+0300  | 
 **fields** | [**[String]**](String.md)| CSV-formatted list of JSON object fields to be returned in reply collection.  | [optional] 

### Return type

[**InlineResponse2005**](InlineResponse2005.md)

### Authorization

[FlespiToken](../README.md#FlespiToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

