# FlespiGatewayRestApi.ConnectionsterminalApi

All URIs are relative to *https://flespi.io/gw*

Method | HTTP request | Description
------------- | ------------- | -------------
[**channelsChSelectorConnectionsConnSelectorTerminalDelete**](ConnectionsterminalApi.md#channelsChSelectorConnectionsConnSelectorTerminalDelete) | **DELETE** /channels/{ch-selector}/connections/{conn-selector}/terminal | Disable terminal mode 
[**channelsChSelectorConnectionsConnSelectorTerminalGet**](ConnectionsterminalApi.md#channelsChSelectorConnectionsConnSelectorTerminalGet) | **GET** /channels/{ch-selector}/connections/{conn-selector}/terminal | Read incoming terminal data 
[**channelsChSelectorConnectionsConnSelectorTerminalPost**](ConnectionsterminalApi.md#channelsChSelectorConnectionsConnSelectorTerminalPost) | **POST** /channels/{ch-selector}/connections/{conn-selector}/terminal | Enable terminal mode for connection 
[**channelsChSelectorConnectionsConnSelectorTerminalPut**](ConnectionsterminalApi.md#channelsChSelectorConnectionsConnSelectorTerminalPut) | **PUT** /channels/{ch-selector}/connections/{conn-selector}/terminal | Send data via terminal connection 


<a name="channelsChSelectorConnectionsConnSelectorTerminalDelete"></a>
# **channelsChSelectorConnectionsConnSelectorTerminalDelete**
> InlineResponse2008 channelsChSelectorConnectionsConnSelectorTerminalDelete(chSelectorconnSelector)

Disable terminal mode 

Disabling terminal mode will close TCP connection. 

### Example
```javascript
var FlespiGatewayRestApi = require('flespi_gateway_rest_api');
var defaultClient = FlespiGatewayRestApi.ApiClient.default;

// Configure API key authorization: FlespiToken
var FlespiToken = defaultClient.authentications['FlespiToken'];
FlespiToken.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//FlespiToken.apiKeyPrefix = 'Token';

var apiInstance = new FlespiGatewayRestApi.ConnectionsterminalApi();

var chSelector = ["chSelector_example"]; // [String] | Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name=mask -name matches wildcard mask   - uri=mask - URI matches wildcard mask   - protocol_id=value - channel's protocol ID matches value   - protocol_name=mask - protocol's name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled=true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled=true,protocol_id=10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled=false | inactive channels from the list of channels with IDs 1,2,3 

var connSelector = ["connSelector_example"]; // [String] | Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - ident=mask - connected device identification string matches wildcard mask   - ip=mask - incoming connection IP address matches wildcard mask   - established⋚value - UNIX timestamp of connection opening is greater or smaller then value  Request example | Description --------- | --------   /channels/all/connections/all | all active TCP connections to all channels   /channels/1,2,3/connections/all | all active TCP connections to channels 1,2,3   /channels/all/connections/ip=127.0.\\*.\\*,all active TCP connections to all channels, from given IP address established after Fri Dec 23 2016 08:52:43 GMT+0300 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.channelsChSelectorConnectionsConnSelectorTerminalDelete(chSelectorconnSelector, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **chSelector** | [**[String]**](String.md)| Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name&#x3D;mask -name matches wildcard mask   - uri&#x3D;mask - URI matches wildcard mask   - protocol_id&#x3D;value - channel&#39;s protocol ID matches value   - protocol_name&#x3D;mask - protocol&#39;s name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled&#x3D;true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled&#x3D;true,protocol_id&#x3D;10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled&#x3D;false | inactive channels from the list of channels with IDs 1,2,3  | 
 **connSelector** | [**[String]**](String.md)| Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - ident&#x3D;mask - connected device identification string matches wildcard mask   - ip&#x3D;mask - incoming connection IP address matches wildcard mask   - established⋚value - UNIX timestamp of connection opening is greater or smaller then value  Request example | Description --------- | --------   /channels/all/connections/all | all active TCP connections to all channels   /channels/1,2,3/connections/all | all active TCP connections to channels 1,2,3   /channels/all/connections/ip&#x3D;127.0.\\*.\\*,all active TCP connections to all channels, from given IP address established after Fri Dec 23 2016 08:52:43 GMT+0300  | 

### Return type

[**InlineResponse2008**](InlineResponse2008.md)

### Authorization

[FlespiToken](../README.md#FlespiToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="channelsChSelectorConnectionsConnSelectorTerminalGet"></a>
# **channelsChSelectorConnectionsConnSelectorTerminalGet**
> InlineResponse2007 channelsChSelectorConnectionsConnSelectorTerminalGet(chSelectorconnSelector, opts)

Read incoming terminal data 

Read data from input buffers of selected TCP connections with terminal mode enabled. 

### Example
```javascript
var FlespiGatewayRestApi = require('flespi_gateway_rest_api');
var defaultClient = FlespiGatewayRestApi.ApiClient.default;

// Configure API key authorization: FlespiToken
var FlespiToken = defaultClient.authentications['FlespiToken'];
FlespiToken.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//FlespiToken.apiKeyPrefix = 'Token';

var apiInstance = new FlespiGatewayRestApi.ConnectionsterminalApi();

var chSelector = ["chSelector_example"]; // [String] | Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name=mask -name matches wildcard mask   - uri=mask - URI matches wildcard mask   - protocol_id=value - channel's protocol ID matches value   - protocol_name=mask - protocol's name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled=true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled=true,protocol_id=10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled=false | inactive channels from the list of channels with IDs 1,2,3 

var connSelector = ["connSelector_example"]; // [String] | Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - ident=mask - connected device identification string matches wildcard mask   - ip=mask - incoming connection IP address matches wildcard mask   - established⋚value - UNIX timestamp of connection opening is greater or smaller then value  Request example | Description --------- | --------   /channels/all/connections/all | all active TCP connections to all channels   /channels/1,2,3/connections/all | all active TCP connections to channels 1,2,3   /channels/all/connections/ip=127.0.\\*.\\*,all active TCP connections to all channels, from given IP address established after Fri Dec 23 2016 08:52:43 GMT+0300 

var opts = { 
  'fields': ["fields_example"], // [String] | CSV-formatted list of JSON object fields to be returned in reply collection. 
  'data': "data_example" // String | 
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.channelsChSelectorConnectionsConnSelectorTerminalGet(chSelectorconnSelector, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **chSelector** | [**[String]**](String.md)| Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name&#x3D;mask -name matches wildcard mask   - uri&#x3D;mask - URI matches wildcard mask   - protocol_id&#x3D;value - channel&#39;s protocol ID matches value   - protocol_name&#x3D;mask - protocol&#39;s name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled&#x3D;true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled&#x3D;true,protocol_id&#x3D;10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled&#x3D;false | inactive channels from the list of channels with IDs 1,2,3  | 
 **connSelector** | [**[String]**](String.md)| Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - ident&#x3D;mask - connected device identification string matches wildcard mask   - ip&#x3D;mask - incoming connection IP address matches wildcard mask   - established⋚value - UNIX timestamp of connection opening is greater or smaller then value  Request example | Description --------- | --------   /channels/all/connections/all | all active TCP connections to all channels   /channels/1,2,3/connections/all | all active TCP connections to channels 1,2,3   /channels/all/connections/ip&#x3D;127.0.\\*.\\*,all active TCP connections to all channels, from given IP address established after Fri Dec 23 2016 08:52:43 GMT+0300  | 
 **fields** | [**[String]**](String.md)| CSV-formatted list of JSON object fields to be returned in reply collection.  | [optional] 
 **data** | **String**|  | [optional] 

### Return type

[**InlineResponse2007**](InlineResponse2007.md)

### Authorization

[FlespiToken](../README.md#FlespiToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="channelsChSelectorConnectionsConnSelectorTerminalPost"></a>
# **channelsChSelectorConnectionsConnSelectorTerminalPost**
> ChannelConnectionId channelsChSelectorConnectionsConnSelectorTerminalPost(chSelectorconnSelector)

Enable terminal mode for connection 

Switch active TCP connection to terminal mode. Channel stops parsing data on this connection. Data can be sent to device via PUT request. Data from device can be read via GET request. 

### Example
```javascript
var FlespiGatewayRestApi = require('flespi_gateway_rest_api');
var defaultClient = FlespiGatewayRestApi.ApiClient.default;

// Configure API key authorization: FlespiToken
var FlespiToken = defaultClient.authentications['FlespiToken'];
FlespiToken.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//FlespiToken.apiKeyPrefix = 'Token';

var apiInstance = new FlespiGatewayRestApi.ConnectionsterminalApi();

var chSelector = ["chSelector_example"]; // [String] | Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name=mask -name matches wildcard mask   - uri=mask - URI matches wildcard mask   - protocol_id=value - channel's protocol ID matches value   - protocol_name=mask - protocol's name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled=true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled=true,protocol_id=10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled=false | inactive channels from the list of channels with IDs 1,2,3 

var connSelector = ["connSelector_example"]; // [String] | Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - ident=mask - connected device identification string matches wildcard mask   - ip=mask - incoming connection IP address matches wildcard mask   - established⋚value - UNIX timestamp of connection opening is greater or smaller then value  Request example | Description --------- | --------   /channels/all/connections/all | all active TCP connections to all channels   /channels/1,2,3/connections/all | all active TCP connections to channels 1,2,3   /channels/all/connections/ip=127.0.\\*.\\*,all active TCP connections to all channels, from given IP address established after Fri Dec 23 2016 08:52:43 GMT+0300 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.channelsChSelectorConnectionsConnSelectorTerminalPost(chSelectorconnSelector, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **chSelector** | [**[String]**](String.md)| Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name&#x3D;mask -name matches wildcard mask   - uri&#x3D;mask - URI matches wildcard mask   - protocol_id&#x3D;value - channel&#39;s protocol ID matches value   - protocol_name&#x3D;mask - protocol&#39;s name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled&#x3D;true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled&#x3D;true,protocol_id&#x3D;10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled&#x3D;false | inactive channels from the list of channels with IDs 1,2,3  | 
 **connSelector** | [**[String]**](String.md)| Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - ident&#x3D;mask - connected device identification string matches wildcard mask   - ip&#x3D;mask - incoming connection IP address matches wildcard mask   - established⋚value - UNIX timestamp of connection opening is greater or smaller then value  Request example | Description --------- | --------   /channels/all/connections/all | all active TCP connections to all channels   /channels/1,2,3/connections/all | all active TCP connections to channels 1,2,3   /channels/all/connections/ip&#x3D;127.0.\\*.\\*,all active TCP connections to all channels, from given IP address established after Fri Dec 23 2016 08:52:43 GMT+0300  | 

### Return type

[**ChannelConnectionId**](ChannelConnectionId.md)

### Authorization

[FlespiToken](../README.md#FlespiToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="channelsChSelectorConnectionsConnSelectorTerminalPut"></a>
# **channelsChSelectorConnectionsConnSelectorTerminalPut**
> InlineResponse2008 channelsChSelectorConnectionsConnSelectorTerminalPut(chSelectorconnSelectordata)

Send data via terminal connection 

Write data to TCP connection with terminal mode enabled. In case if both **text** and **hex** parameters are used hex data will be send following after text data. 

### Example
```javascript
var FlespiGatewayRestApi = require('flespi_gateway_rest_api');
var defaultClient = FlespiGatewayRestApi.ApiClient.default;

// Configure API key authorization: FlespiToken
var FlespiToken = defaultClient.authentications['FlespiToken'];
FlespiToken.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//FlespiToken.apiKeyPrefix = 'Token';

var apiInstance = new FlespiGatewayRestApi.ConnectionsterminalApi();

var chSelector = ["chSelector_example"]; // [String] | Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name=mask -name matches wildcard mask   - uri=mask - URI matches wildcard mask   - protocol_id=value - channel's protocol ID matches value   - protocol_name=mask - protocol's name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled=true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled=true,protocol_id=10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled=false | inactive channels from the list of channels with IDs 1,2,3 

var connSelector = ["connSelector_example"]; // [String] | Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - ident=mask - connected device identification string matches wildcard mask   - ip=mask - incoming connection IP address matches wildcard mask   - established⋚value - UNIX timestamp of connection opening is greater or smaller then value  Request example | Description --------- | --------   /channels/all/connections/all | all active TCP connections to all channels   /channels/1,2,3/connections/all | all active TCP connections to channels 1,2,3   /channels/all/connections/ip=127.0.\\*.\\*,all active TCP connections to all channels, from given IP address established after Fri Dec 23 2016 08:52:43 GMT+0300 

var data = new FlespiGatewayRestApi.ChannelConnectionTerminal(); // ChannelConnectionTerminal | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.channelsChSelectorConnectionsConnSelectorTerminalPut(chSelectorconnSelectordata, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **chSelector** | [**[String]**](String.md)| Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name&#x3D;mask -name matches wildcard mask   - uri&#x3D;mask - URI matches wildcard mask   - protocol_id&#x3D;value - channel&#39;s protocol ID matches value   - protocol_name&#x3D;mask - protocol&#39;s name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled&#x3D;true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled&#x3D;true,protocol_id&#x3D;10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled&#x3D;false | inactive channels from the list of channels with IDs 1,2,3  | 
 **connSelector** | [**[String]**](String.md)| Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - ident&#x3D;mask - connected device identification string matches wildcard mask   - ip&#x3D;mask - incoming connection IP address matches wildcard mask   - established⋚value - UNIX timestamp of connection opening is greater or smaller then value  Request example | Description --------- | --------   /channels/all/connections/all | all active TCP connections to all channels   /channels/1,2,3/connections/all | all active TCP connections to channels 1,2,3   /channels/all/connections/ip&#x3D;127.0.\\*.\\*,all active TCP connections to all channels, from given IP address established after Fri Dec 23 2016 08:52:43 GMT+0300  | 
 **data** | [**ChannelConnectionTerminal**](ChannelConnectionTerminal.md)|  | 

### Return type

[**InlineResponse2008**](InlineResponse2008.md)

### Authorization

[FlespiToken](../README.md#FlespiToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

