# FlespiGatewayRestApi.LogsApi

All URIs are relative to *https://flespi.io/gw*

Method | HTTP request | Description
------------- | ------------- | -------------
[**channelsChSelectorLogsGet**](LogsApi.md#channelsChSelectorLogsGet) | **GET** /channels/{ch-selector}/logs | Get channel&#39;s significant events records 


<a name="channelsChSelectorLogsGet"></a>
# **channelsChSelectorLogsGet**
> InlineResponse2009 channelsChSelectorLogsGet(chSelector, opts)

Get channel&#39;s significant events records 

Get specified channels logs. The request without parameters will return all channels logs.  Reply contains sorted by time logs (without sorting by channel)  Filter parameter can be used to specify logs request. It is represented by CSV-formatted option list. One option is represented by:   * parameter-operand-value expression, e.g. parameter_name&#x3D;value* or param&#x3D;1   * just parameter_name (without operand and expression) - filter messages by existance of specified parameter_name  Possible operands:   * numeric comparison (&#x3D;, !&#x3D;, &amp;lt;&#x3D;, &amp;gt;&#x3D;, &amp;lt;, &amp;gt;)   * text mask correspondance: &#39;&#x3D;&#39; for mask match, &#39;!&#x3D;&#39; for mask mismatch  E.g. following the list    **param1&#x3D;name*,param2,param3&gt;&#x3D;5**  will return list of messages with:   * param1 string value starts with \&quot;name\&quot;-symbols   * existing parameter named \&quot;param2\&quot;   * with param3 numeric value greater or equal to 5 

### Example
```javascript
var FlespiGatewayRestApi = require('flespi_gateway_rest_api');
var defaultClient = FlespiGatewayRestApi.ApiClient.default;

// Configure API key authorization: FlespiToken
var FlespiToken = defaultClient.authentications['FlespiToken'];
FlespiToken.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//FlespiToken.apiKeyPrefix = 'Token';

var apiInstance = new FlespiGatewayRestApi.LogsApi();

var chSelector = ["chSelector_example"]; // [String] | Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name=mask -name matches wildcard mask   - uri=mask - URI matches wildcard mask   - protocol_id=value - channel's protocol ID matches value   - protocol_name=mask - protocol's name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled=true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled=true,protocol_id=10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled=false | inactive channels from the list of channels with IDs 1,2,3 

var opts = { 
  'data': "data_example" // String | Parameters to generate log sample. 
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.channelsChSelectorLogsGet(chSelector, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **chSelector** | [**[String]**](String.md)| Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name&#x3D;mask -name matches wildcard mask   - uri&#x3D;mask - URI matches wildcard mask   - protocol_id&#x3D;value - channel&#39;s protocol ID matches value   - protocol_name&#x3D;mask - protocol&#39;s name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled&#x3D;true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled&#x3D;true,protocol_id&#x3D;10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled&#x3D;false | inactive channels from the list of channels with IDs 1,2,3  | 
 **data** | **String**| Parameters to generate log sample.  | [optional] 

### Return type

[**InlineResponse2009**](InlineResponse2009.md)

### Authorization

[FlespiToken](../README.md#FlespiToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

