# FlespiGatewayRestApi.ProtocolsApi

All URIs are relative to *https://flespi.io/gw*

Method | HTTP request | Description
------------- | ------------- | -------------
[**protocolsProtocolSelectorGet**](ProtocolsApi.md#protocolsProtocolSelectorGet) | **GET** /protocols/{protocol-selector} | Get protocols meeting filtering conditions


<a name="protocolsProtocolSelectorGet"></a>
# **protocolsProtocolSelectorGet**
> InlineResponse200 protocolsProtocolSelectorGet(protocolSelector, opts)

Get protocols meeting filtering conditions

Get collection of protocols matching filter parameters. Use special keyword \&quot;all\&quot; to retreieve all protocols. 

### Example
```javascript
var FlespiGatewayRestApi = require('flespi_gateway_rest_api');
var defaultClient = FlespiGatewayRestApi.ApiClient.default;

// Configure API key authorization: FlespiToken
var FlespiToken = defaultClient.authentications['FlespiToken'];
FlespiToken.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//FlespiToken.apiKeyPrefix = 'Token';

var apiInstance = new FlespiGatewayRestApi.ProtocolsApi();

var protocolSelector = ["protocolSelector_example"]; // [String] | Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - name=mask - protocol name matches wildcard mask   - description=mask - description matches wildcard mask   Request example | Description --------- | --------   /protocols/name=\\*gurtam\\* | all protocols with keyword \"gurtam\" in **name** field 

var opts = { 
  'fields': ["fields_example"] // [String] | CSV-formatted list of JSON object fields to be returned in reply collection. 
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.protocolsProtocolSelectorGet(protocolSelector, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **protocolSelector** | [**[String]**](String.md)| Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - name&#x3D;mask - protocol name matches wildcard mask   - description&#x3D;mask - description matches wildcard mask   Request example | Description --------- | --------   /protocols/name&#x3D;\\*gurtam\\* | all protocols with keyword \&quot;gurtam\&quot; in **name** field  | 
 **fields** | [**[String]**](String.md)| CSV-formatted list of JSON object fields to be returned in reply collection.  | [optional] 

### Return type

[**InlineResponse200**](InlineResponse200.md)

### Authorization

[FlespiToken](../README.md#FlespiToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

