/**
 * flespi gateway REST API 
 * **DISCLAIMER**: This is a beta version of the flespi gateway API, in the process of being tested before its official release on 31 May, 2017. Being so, there is no guarantee that system architecture will not change until release date.  This API provides methods to set up and manage data flow channels from tracking devices to [flespi gateway](https://flespi.com/gateway) and further to your application. While raw data from devices comes in unparsed and fragmented way, flespi gateway takes on work to analyze incoming data from different types of hardware, registers it to unified-formatted messages and provides easy and reliable access to tracker's data for your software. Note that access to messages from trackers is provided in a **single reader** way, i.e. stable reading can be carried out by only one worker.  To perform operations above you need to specify FlespiToken key provided on entrance to your personal account (this key is to be passed in REST API call via header: **Authorization: FlespiToken XXXXXXXXXX**).  Detailed REST API description provided in [guidelines](https://flespi.com/api-guidelines). 
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ChannelCommandQueuePut', 'model/ChannelCommandsQueuePost', 'model/InlineResponse2003'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/ChannelCommandQueuePut'), require('../model/ChannelCommandsQueuePost'), require('../model/InlineResponse2003'));
  } else {
    // Browser globals (root is window)
    if (!root.FlespiGatewayRestApi) {
      root.FlespiGatewayRestApi = {};
    }
    root.FlespiGatewayRestApi.CommandsqueueApi = factory(root.FlespiGatewayRestApi.ApiClient, root.FlespiGatewayRestApi.ChannelCommandQueuePut, root.FlespiGatewayRestApi.ChannelCommandsQueuePost, root.FlespiGatewayRestApi.InlineResponse2003);
  }
}(this, function(ApiClient, ChannelCommandQueuePut, ChannelCommandsQueuePost, InlineResponse2003) {
  'use strict';

  /**
   * Commandsqueue service.
   * @module api/CommandsqueueApi
   * @version 1.0
   */

  /**
   * Constructs a new CommandsqueueApi. 
   * @alias module:api/CommandsqueueApi
   * @class
   * @param {module:ApiClient} apiClient Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the channelsChSelectorCommandsQueueCmdQueueSelectorDelete operation.
     * @callback module:api/CommandsqueueApi~channelsChSelectorCommandsQueueCmdQueueSelectorDeleteCallback
     * @param {String} error Error message, if any.
     * @param {module:model/InlineResponse2003} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Remove commands from queue 
     * Delete commands meeting filtering conditions for specified channels. 
     * @param {Array.<String>} chSelector Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name&#x3D;mask -name matches wildcard mask   - uri&#x3D;mask - URI matches wildcard mask   - protocol_id&#x3D;value - channel&#39;s protocol ID matches value   - protocol_name&#x3D;mask - protocol&#39;s name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled&#x3D;true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled&#x3D;true,protocol_id&#x3D;10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled&#x3D;false | inactive channels from the list of channels with IDs 1,2,3 
     * @param {Array.<String>} cmdQueueSelector Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - ident&#x3D;mask - connected device identification string matches wildcard mask   - executed&#x3D;true/false - flag that command have been already executed   Request example | Description --------- | --------   /channels/all/commands/all | all created commands on all channels   /channels/1,2,3/commands/all | all created commands on channels 1,2,3   /channels/all/commands/executed&#x3D;true | all executed commands on all channels 
     * @param {module:api/CommandsqueueApi~channelsChSelectorCommandsQueueCmdQueueSelectorDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/InlineResponse2003}
     */
    this.channelsChSelectorCommandsQueueCmdQueueSelectorDelete = function(chSelector, cmdQueueSelector, callback) {
      var postBody = null;

      // verify the required parameter 'chSelector' is set
      if (chSelector == undefined || chSelector == null) {
        throw new Error("Missing the required parameter 'chSelector' when calling channelsChSelectorCommandsQueueCmdQueueSelectorDelete");
      }

      // verify the required parameter 'cmdQueueSelector' is set
      if (cmdQueueSelector == undefined || cmdQueueSelector == null) {
        throw new Error("Missing the required parameter 'cmdQueueSelector' when calling channelsChSelectorCommandsQueueCmdQueueSelectorDelete");
      }


      var pathParams = {
        'ch-selector': chSelector,
        'cmd-queue-selector': cmdQueueSelector
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['FlespiToken'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = InlineResponse2003;

      return this.apiClient.callApi(
        '/channels/{ch-selector}/commands-queue/{cmd-queue-selector}', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the channelsChSelectorCommandsQueueCmdQueueSelectorGet operation.
     * @callback module:api/CommandsqueueApi~channelsChSelectorCommandsQueueCmdQueueSelectorGetCallback
     * @param {String} error Error message, if any.
     * @param {module:model/InlineResponse2003} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get commands from the queue 
     * Get commands waiting to be sent meeting filtering conditions. 
     * @param {Array.<String>} chSelector Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name&#x3D;mask -name matches wildcard mask   - uri&#x3D;mask - URI matches wildcard mask   - protocol_id&#x3D;value - channel&#39;s protocol ID matches value   - protocol_name&#x3D;mask - protocol&#39;s name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled&#x3D;true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled&#x3D;true,protocol_id&#x3D;10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled&#x3D;false | inactive channels from the list of channels with IDs 1,2,3 
     * @param {Array.<String>} cmdQueueSelector Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - ident&#x3D;mask - connected device identification string matches wildcard mask   - executed&#x3D;true/false - flag that command have been already executed   Request example | Description --------- | --------   /channels/all/commands/all | all created commands on all channels   /channels/1,2,3/commands/all | all created commands on channels 1,2,3   /channels/all/commands/executed&#x3D;true | all executed commands on all channels 
     * @param {Object} opts Optional parameters
     * @param {Array.<module:model/String>} opts.fields CSV-formatted list of JSON object fields to be returned in reply collection. 
     * @param {module:api/CommandsqueueApi~channelsChSelectorCommandsQueueCmdQueueSelectorGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/InlineResponse2003}
     */
    this.channelsChSelectorCommandsQueueCmdQueueSelectorGet = function(chSelector, cmdQueueSelector, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'chSelector' is set
      if (chSelector == undefined || chSelector == null) {
        throw new Error("Missing the required parameter 'chSelector' when calling channelsChSelectorCommandsQueueCmdQueueSelectorGet");
      }

      // verify the required parameter 'cmdQueueSelector' is set
      if (cmdQueueSelector == undefined || cmdQueueSelector == null) {
        throw new Error("Missing the required parameter 'cmdQueueSelector' when calling channelsChSelectorCommandsQueueCmdQueueSelectorGet");
      }


      var pathParams = {
        'ch-selector': chSelector,
        'cmd-queue-selector': cmdQueueSelector
      };
      var queryParams = {
        'fields': this.apiClient.buildCollectionParam(opts['fields'], 'csv')
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['FlespiToken'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = InlineResponse2003;

      return this.apiClient.callApi(
        '/channels/{ch-selector}/commands-queue/{cmd-queue-selector}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the channelsChSelectorCommandsQueueCmdQueueSelectorPut operation.
     * @callback module:api/CommandsqueueApi~channelsChSelectorCommandsQueueCmdQueueSelectorPutCallback
     * @param {String} error Error message, if any.
     * @param {module:model/InlineResponse2003} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Change command&#39;s fields 
     * Make changes in commands fields. Apply to commands meeting filtering conditions. 
     * @param {Array.<String>} chSelector Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name&#x3D;mask -name matches wildcard mask   - uri&#x3D;mask - URI matches wildcard mask   - protocol_id&#x3D;value - channel&#39;s protocol ID matches value   - protocol_name&#x3D;mask - protocol&#39;s name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled&#x3D;true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled&#x3D;true,protocol_id&#x3D;10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled&#x3D;false | inactive channels from the list of channels with IDs 1,2,3 
     * @param {Array.<String>} cmdQueueSelector Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - ident&#x3D;mask - connected device identification string matches wildcard mask   - executed&#x3D;true/false - flag that command have been already executed   Request example | Description --------- | --------   /channels/all/commands/all | all created commands on all channels   /channels/1,2,3/commands/all | all created commands on channels 1,2,3   /channels/all/commands/executed&#x3D;true | all executed commands on all channels 
     * @param {module:model/ChannelCommandQueuePut} data 
     * @param {Object} opts Optional parameters
     * @param {Array.<module:model/String>} opts.fields CSV-formatted list of JSON object fields to be returned in reply collection. 
     * @param {module:api/CommandsqueueApi~channelsChSelectorCommandsQueueCmdQueueSelectorPutCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/InlineResponse2003}
     */
    this.channelsChSelectorCommandsQueueCmdQueueSelectorPut = function(chSelector, cmdQueueSelector, data, opts, callback) {
      opts = opts || {};
      var postBody = data;

      // verify the required parameter 'chSelector' is set
      if (chSelector == undefined || chSelector == null) {
        throw new Error("Missing the required parameter 'chSelector' when calling channelsChSelectorCommandsQueueCmdQueueSelectorPut");
      }

      // verify the required parameter 'cmdQueueSelector' is set
      if (cmdQueueSelector == undefined || cmdQueueSelector == null) {
        throw new Error("Missing the required parameter 'cmdQueueSelector' when calling channelsChSelectorCommandsQueueCmdQueueSelectorPut");
      }

      // verify the required parameter 'data' is set
      if (data == undefined || data == null) {
        throw new Error("Missing the required parameter 'data' when calling channelsChSelectorCommandsQueueCmdQueueSelectorPut");
      }


      var pathParams = {
        'ch-selector': chSelector,
        'cmd-queue-selector': cmdQueueSelector
      };
      var queryParams = {
        'fields': this.apiClient.buildCollectionParam(opts['fields'], 'csv')
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['FlespiToken'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = InlineResponse2003;

      return this.apiClient.callApi(
        '/channels/{ch-selector}/commands-queue/{cmd-queue-selector}', 'PUT',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the channelsChSelectorCommandsQueuePost operation.
     * @callback module:api/CommandsqueueApi~channelsChSelectorCommandsQueuePostCallback
     * @param {String} error Error message, if any.
     * @param {module:model/InlineResponse2003} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add command to commands buffer 
     * Add command to commands queue. Command would be delivered to the device with coresponding ident as soon as there will be established connection from it to the channel. The command to given **ident** would be added for every channel specified by **{ch-selector}**. 
     * @param {Array.<String>} chSelector Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name&#x3D;mask -name matches wildcard mask   - uri&#x3D;mask - URI matches wildcard mask   - protocol_id&#x3D;value - channel&#39;s protocol ID matches value   - protocol_name&#x3D;mask - protocol&#39;s name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled&#x3D;true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled&#x3D;true,protocol_id&#x3D;10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled&#x3D;false | inactive channels from the list of channels with IDs 1,2,3 
     * @param {Array.<module:model/ChannelCommandsQueuePost>} data 
     * @param {Object} opts Optional parameters
     * @param {Array.<module:model/String>} opts.fields CSV-formatted list of JSON object fields to be returned in reply collection. 
     * @param {module:api/CommandsqueueApi~channelsChSelectorCommandsQueuePostCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/InlineResponse2003}
     */
    this.channelsChSelectorCommandsQueuePost = function(chSelector, data, opts, callback) {
      opts = opts || {};
      var postBody = data;

      // verify the required parameter 'chSelector' is set
      if (chSelector == undefined || chSelector == null) {
        throw new Error("Missing the required parameter 'chSelector' when calling channelsChSelectorCommandsQueuePost");
      }

      // verify the required parameter 'data' is set
      if (data == undefined || data == null) {
        throw new Error("Missing the required parameter 'data' when calling channelsChSelectorCommandsQueuePost");
      }


      var pathParams = {
        'ch-selector': chSelector
      };
      var queryParams = {
        'fields': this.apiClient.buildCollectionParam(opts['fields'], 'csv')
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['FlespiToken'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = InlineResponse2003;

      return this.apiClient.callApi(
        '/channels/{ch-selector}/commands-queue', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
