/**
 * flespi gateway REST API 
 * **DISCLAIMER**: This is a beta version of the flespi gateway API, in the process of being tested before its official release on 31 May, 2017. Being so, there is no guarantee that system architecture will not change until release date.  This API provides methods to set up and manage data flow channels from tracking devices to [flespi gateway](https://flespi.com/gateway) and further to your application. While raw data from devices comes in unparsed and fragmented way, flespi gateway takes on work to analyze incoming data from different types of hardware, registers it to unified-formatted messages and provides easy and reliable access to tracker's data for your software. Note that access to messages from trackers is provided in a **single reader** way, i.e. stable reading can be carried out by only one worker.  To perform operations above you need to specify FlespiToken key provided on entrance to your personal account (this key is to be passed in REST API call via header: **Authorization: FlespiToken XXXXXXXXXX**).  Detailed REST API description provided in [guidelines](https://flespi.com/api-guidelines). 
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/InlineResponse2005', 'model/InlineResponse2006'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/InlineResponse2005'), require('../model/InlineResponse2006'));
  } else {
    // Browser globals (root is window)
    if (!root.FlespiGatewayRestApi) {
      root.FlespiGatewayRestApi = {};
    }
    root.FlespiGatewayRestApi.ConnectionsApi = factory(root.FlespiGatewayRestApi.ApiClient, root.FlespiGatewayRestApi.InlineResponse2005, root.FlespiGatewayRestApi.InlineResponse2006);
  }
}(this, function(ApiClient, InlineResponse2005, InlineResponse2006) {
  'use strict';

  /**
   * Connections service.
   * @module api/ConnectionsApi
   * @version 1.0
   */

  /**
   * Constructs a new ConnectionsApi. 
   * @alias module:api/ConnectionsApi
   * @class
   * @param {module:ApiClient} apiClient Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the channelsChSelectorConnectionsConnSelectorDelete operation.
     * @callback module:api/ConnectionsApi~channelsChSelectorConnectionsConnSelectorDeleteCallback
     * @param {String} error Error message, if any.
     * @param {module:model/InlineResponse2006} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Close TCP connections 
     * Close selected TCP connections to selected channels. 
     * @param {Array.<String>} chSelector Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name&#x3D;mask -name matches wildcard mask   - uri&#x3D;mask - URI matches wildcard mask   - protocol_id&#x3D;value - channel&#39;s protocol ID matches value   - protocol_name&#x3D;mask - protocol&#39;s name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled&#x3D;true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled&#x3D;true,protocol_id&#x3D;10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled&#x3D;false | inactive channels from the list of channels with IDs 1,2,3 
     * @param {Array.<String>} connSelector Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - ident&#x3D;mask - connected device identification string matches wildcard mask   - ip&#x3D;mask - incoming connection IP address matches wildcard mask   - established⋚value - UNIX timestamp of connection opening is greater or smaller then value  Request example | Description --------- | --------   /channels/all/connections/all | all active TCP connections to all channels   /channels/1,2,3/connections/all | all active TCP connections to channels 1,2,3   /channels/all/connections/ip&#x3D;127.0.\\*.\\*,all active TCP connections to all channels, from given IP address established after Fri Dec 23 2016 08:52:43 GMT+0300 
     * @param {module:api/ConnectionsApi~channelsChSelectorConnectionsConnSelectorDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/InlineResponse2006}
     */
    this.channelsChSelectorConnectionsConnSelectorDelete = function(chSelector, connSelector, callback) {
      var postBody = null;

      // verify the required parameter 'chSelector' is set
      if (chSelector == undefined || chSelector == null) {
        throw new Error("Missing the required parameter 'chSelector' when calling channelsChSelectorConnectionsConnSelectorDelete");
      }

      // verify the required parameter 'connSelector' is set
      if (connSelector == undefined || connSelector == null) {
        throw new Error("Missing the required parameter 'connSelector' when calling channelsChSelectorConnectionsConnSelectorDelete");
      }


      var pathParams = {
        'ch-selector': chSelector,
        'conn-selector': connSelector
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['FlespiToken'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = InlineResponse2006;

      return this.apiClient.callApi(
        '/channels/{ch-selector}/connections/{conn-selector}', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the channelsChSelectorConnectionsConnSelectorGet operation.
     * @callback module:api/ConnectionsApi~channelsChSelectorConnectionsConnSelectorGetCallback
     * @param {String} error Error message, if any.
     * @param {module:model/InlineResponse2005} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List active TCP connections 
     * List active TCP connections matchnig filtering parameters to selected channels. 
     * @param {Array.<String>} chSelector Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Use additional filter (CSV-formatted, applied with logical AND condition):   - name&#x3D;mask -name matches wildcard mask   - uri&#x3D;mask - URI matches wildcard mask   - protocol_id&#x3D;value - channel&#39;s protocol ID matches value   - protocol_name&#x3D;mask - protocol&#39;s name matches wildcard mask   - logs_period⋚value - logs storage period is greater, smaller or equal to value   - enabled&#x3D;true/false - if channel is in active/inactive mode  Request example | Description --------- | --------   /channels/all | all channels   /channels/1,2,3 | channels with IDs 1,2,3   /channels/enabled&#x3D;true,protocol_id&#x3D;10 | all active channels using protocol with ID 10   /channels/1,2,3,enabled&#x3D;false | inactive channels from the list of channels with IDs 1,2,3 
     * @param {Array.<String>} connSelector Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - ident&#x3D;mask - connected device identification string matches wildcard mask   - ip&#x3D;mask - incoming connection IP address matches wildcard mask   - established⋚value - UNIX timestamp of connection opening is greater or smaller then value  Request example | Description --------- | --------   /channels/all/connections/all | all active TCP connections to all channels   /channels/1,2,3/connections/all | all active TCP connections to channels 1,2,3   /channels/all/connections/ip&#x3D;127.0.\\*.\\*,all active TCP connections to all channels, from given IP address established after Fri Dec 23 2016 08:52:43 GMT+0300 
     * @param {Object} opts Optional parameters
     * @param {Array.<module:model/String>} opts.fields CSV-formatted list of JSON object fields to be returned in reply collection. 
     * @param {module:api/ConnectionsApi~channelsChSelectorConnectionsConnSelectorGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/InlineResponse2005}
     */
    this.channelsChSelectorConnectionsConnSelectorGet = function(chSelector, connSelector, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'chSelector' is set
      if (chSelector == undefined || chSelector == null) {
        throw new Error("Missing the required parameter 'chSelector' when calling channelsChSelectorConnectionsConnSelectorGet");
      }

      // verify the required parameter 'connSelector' is set
      if (connSelector == undefined || connSelector == null) {
        throw new Error("Missing the required parameter 'connSelector' when calling channelsChSelectorConnectionsConnSelectorGet");
      }


      var pathParams = {
        'ch-selector': chSelector,
        'conn-selector': connSelector
      };
      var queryParams = {
        'fields': this.apiClient.buildCollectionParam(opts['fields'], 'csv')
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['FlespiToken'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = InlineResponse2005;

      return this.apiClient.callApi(
        '/channels/{ch-selector}/connections/{conn-selector}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
