/**
 * flespi gateway REST API 
 * **DISCLAIMER**: This is a beta version of the flespi gateway API, in the process of being tested before its official release on 31 May, 2017. Being so, there is no guarantee that system architecture will not change until release date.  This API provides methods to set up and manage data flow channels from tracking devices to [flespi gateway](https://flespi.com/gateway) and further to your application. While raw data from devices comes in unparsed and fragmented way, flespi gateway takes on work to analyze incoming data from different types of hardware, registers it to unified-formatted messages and provides easy and reliable access to tracker's data for your software. Note that access to messages from trackers is provided in a **single reader** way, i.e. stable reading can be carried out by only one worker.  To perform operations above you need to specify FlespiToken key provided on entrance to your personal account (this key is to be passed in REST API call via header: **Authorization: FlespiToken XXXXXXXXXX**).  Detailed REST API description provided in [guidelines](https://flespi.com/api-guidelines). 
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/InlineResponse200'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/InlineResponse200'));
  } else {
    // Browser globals (root is window)
    if (!root.FlespiGatewayRestApi) {
      root.FlespiGatewayRestApi = {};
    }
    root.FlespiGatewayRestApi.ProtocolsApi = factory(root.FlespiGatewayRestApi.ApiClient, root.FlespiGatewayRestApi.InlineResponse200);
  }
}(this, function(ApiClient, InlineResponse200) {
  'use strict';

  /**
   * Protocols service.
   * @module api/ProtocolsApi
   * @version 1.0
   */

  /**
   * Constructs a new ProtocolsApi. 
   * @alias module:api/ProtocolsApi
   * @class
   * @param {module:ApiClient} apiClient Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the protocolsProtocolSelectorGet operation.
     * @callback module:api/ProtocolsApi~protocolsProtocolSelectorGetCallback
     * @param {String} error Error message, if any.
     * @param {module:model/InlineResponse200} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get protocols meeting filtering conditions
     * Get collection of protocols matching filter parameters. Use special keyword \&quot;all\&quot; to retreieve all protocols. 
     * @param {Array.<String>} protocolSelector Requested elements selecting template:   - **all** - choose all possible elements   - 1,2,3,... - choose elements by ID list  Apply additional filter (CSV-formatted, applied with logical AND condition)   - name&#x3D;mask - protocol name matches wildcard mask   - description&#x3D;mask - description matches wildcard mask   Request example | Description --------- | --------   /protocols/name&#x3D;\\*gurtam\\* | all protocols with keyword \&quot;gurtam\&quot; in **name** field 
     * @param {Object} opts Optional parameters
     * @param {Array.<module:model/String>} opts.fields CSV-formatted list of JSON object fields to be returned in reply collection. 
     * @param {module:api/ProtocolsApi~protocolsProtocolSelectorGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/InlineResponse200}
     */
    this.protocolsProtocolSelectorGet = function(protocolSelector, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'protocolSelector' is set
      if (protocolSelector == undefined || protocolSelector == null) {
        throw new Error("Missing the required parameter 'protocolSelector' when calling protocolsProtocolSelectorGet");
      }


      var pathParams = {
        'protocol-selector': protocolSelector
      };
      var queryParams = {
        'fields': this.apiClient.buildCollectionParam(opts['fields'], 'csv')
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['FlespiToken'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = InlineResponse200;

      return this.apiClient.callApi(
        '/protocols/{protocol-selector}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
