/**
 * flespi gateway REST API 
 * **DISCLAIMER**: This is a beta version of the flespi gateway API, in the process of being tested before its official release on 31 May, 2017. Being so, there is no guarantee that system architecture will not change until release date.  This API provides methods to set up and manage data flow channels from tracking devices to [flespi gateway](https://flespi.com/gateway) and further to your application. While raw data from devices comes in unparsed and fragmented way, flespi gateway takes on work to analyze incoming data from different types of hardware, registers it to unified-formatted messages and provides easy and reliable access to tracker's data for your software. Note that access to messages from trackers is provided in a **single reader** way, i.e. stable reading can be carried out by only one worker.  To perform operations above you need to specify FlespiToken key provided on entrance to your personal account (this key is to be passed in REST API call via header: **Authorization: FlespiToken XXXXXXXXXX**).  Detailed REST API description provided in [guidelines](https://flespi.com/api-guidelines). 
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 */

(function(factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Channel', 'model/ChannelCommandQueue', 'model/ChannelCommandQueueChannelId', 'model/ChannelCommandQueueExpires', 'model/ChannelCommandQueueId', 'model/ChannelCommandQueueIdent', 'model/ChannelCommandQueuePayload', 'model/ChannelCommandQueuePut', 'model/ChannelCommandResult', 'model/ChannelCommandResultExecuted', 'model/ChannelCommandResultResponse', 'model/ChannelCommandsQueuePost', 'model/ChannelConnection', 'model/ChannelConnectionChannelId', 'model/ChannelConnectionEstablished', 'model/ChannelConnectionId', 'model/ChannelConnectionIdent', 'model/ChannelConnectionIp', 'model/ChannelConnectionTerminal', 'model/ChannelConnectionTerminalGet', 'model/ChannelEnabled', 'model/ChannelId', 'model/ChannelLogmessage', 'model/ChannelLogsPeriod', 'model/ChannelMessage', 'model/ChannelMessageParameter', 'model/ChannelMessageParameters', 'model/ChannelName', 'model/ChannelPost', 'model/ChannelProtocolId', 'model/ChannelProtocolName', 'model/ChannelPut', 'model/ChannelUri', 'model/Channels', 'model/ChannelsId', 'model/Data', 'model/Data1', 'model/Error', 'model/InlineResponse200', 'model/InlineResponse2001', 'model/InlineResponse2002', 'model/InlineResponse2003', 'model/InlineResponse2004', 'model/InlineResponse2005', 'model/InlineResponse2006', 'model/InlineResponse2007', 'model/InlineResponse2008', 'model/InlineResponse2009', 'model/Protocol', 'model/ProtocolDescription', 'model/ProtocolId', 'model/ProtocolName', 'api/ChannelsApi', 'api/CommandsqueueApi', 'api/CommandsresultApi', 'api/ConnectionsApi', 'api/ConnectionsterminalApi', 'api/LogsApi', 'api/MessagesApi', 'api/ProtocolsApi'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('./ApiClient'), require('./model/Channel'), require('./model/ChannelCommandQueue'), require('./model/ChannelCommandQueueChannelId'), require('./model/ChannelCommandQueueExpires'), require('./model/ChannelCommandQueueId'), require('./model/ChannelCommandQueueIdent'), require('./model/ChannelCommandQueuePayload'), require('./model/ChannelCommandQueuePut'), require('./model/ChannelCommandResult'), require('./model/ChannelCommandResultExecuted'), require('./model/ChannelCommandResultResponse'), require('./model/ChannelCommandsQueuePost'), require('./model/ChannelConnection'), require('./model/ChannelConnectionChannelId'), require('./model/ChannelConnectionEstablished'), require('./model/ChannelConnectionId'), require('./model/ChannelConnectionIdent'), require('./model/ChannelConnectionIp'), require('./model/ChannelConnectionTerminal'), require('./model/ChannelConnectionTerminalGet'), require('./model/ChannelEnabled'), require('./model/ChannelId'), require('./model/ChannelLogmessage'), require('./model/ChannelLogsPeriod'), require('./model/ChannelMessage'), require('./model/ChannelMessageParameter'), require('./model/ChannelMessageParameters'), require('./model/ChannelName'), require('./model/ChannelPost'), require('./model/ChannelProtocolId'), require('./model/ChannelProtocolName'), require('./model/ChannelPut'), require('./model/ChannelUri'), require('./model/Channels'), require('./model/ChannelsId'), require('./model/Data'), require('./model/Data1'), require('./model/Error'), require('./model/InlineResponse200'), require('./model/InlineResponse2001'), require('./model/InlineResponse2002'), require('./model/InlineResponse2003'), require('./model/InlineResponse2004'), require('./model/InlineResponse2005'), require('./model/InlineResponse2006'), require('./model/InlineResponse2007'), require('./model/InlineResponse2008'), require('./model/InlineResponse2009'), require('./model/Protocol'), require('./model/ProtocolDescription'), require('./model/ProtocolId'), require('./model/ProtocolName'), require('./api/ChannelsApi'), require('./api/CommandsqueueApi'), require('./api/CommandsresultApi'), require('./api/ConnectionsApi'), require('./api/ConnectionsterminalApi'), require('./api/LogsApi'), require('./api/MessagesApi'), require('./api/ProtocolsApi'));
  }
}(function(ApiClient, Channel, ChannelCommandQueue, ChannelCommandQueueChannelId, ChannelCommandQueueExpires, ChannelCommandQueueId, ChannelCommandQueueIdent, ChannelCommandQueuePayload, ChannelCommandQueuePut, ChannelCommandResult, ChannelCommandResultExecuted, ChannelCommandResultResponse, ChannelCommandsQueuePost, ChannelConnection, ChannelConnectionChannelId, ChannelConnectionEstablished, ChannelConnectionId, ChannelConnectionIdent, ChannelConnectionIp, ChannelConnectionTerminal, ChannelConnectionTerminalGet, ChannelEnabled, ChannelId, ChannelLogmessage, ChannelLogsPeriod, ChannelMessage, ChannelMessageParameter, ChannelMessageParameters, ChannelName, ChannelPost, ChannelProtocolId, ChannelProtocolName, ChannelPut, ChannelUri, Channels, ChannelsId, Data, Data1, Error, InlineResponse200, InlineResponse2001, InlineResponse2002, InlineResponse2003, InlineResponse2004, InlineResponse2005, InlineResponse2006, InlineResponse2007, InlineResponse2008, InlineResponse2009, Protocol, ProtocolDescription, ProtocolId, ProtocolName, ChannelsApi, CommandsqueueApi, CommandsresultApi, ConnectionsApi, ConnectionsterminalApi, LogsApi, MessagesApi, ProtocolsApi) {
  'use strict';

  /**
   * DISCLAIMER_This_is_a_beta_version_of_the_flespi_gateway_API_in_the_process_of_being_tested_before_its_official_release_on_31_May_2017__Being_so_there_is_no_guarantee_that_system_architecture_will_not_change_until_release_date_This_API_provides_methods_to_set_up_and_manage_data_flow_channels_from_tracking_devices_to__flespi_gateway_httpsflespi_comgateway_and_further_to_your_application__While_raw_data_from_devices_comes_in_unparsed_and_fragmented_way_flespi_gateway_takes_on_work_to_analyze_incoming_data_from_different_types_of_hardware_registers_it_to_unified_formatted_messages_and_provides_easy_and_reliable_access_to_trackers_data_for_your_software__Note_that_access_to_messages_from_trackers_is_provided_in_a_single_reader_way_i_e__stable_reading_can_be_carried_out_by_only_one_worker_To_perform_operations_above_you_need_to_specify_FlespiToken_key_provided_on_entrance_to_your_personal_account__this_key_is_to_be_passed_in_REST_API_call_via_header_Authorization_FlespiToken_XXXXXXXXXX_Detailed_REST_API_description_provided_in__guidelines_httpsflespi_comapi_guidelines_.<br>
   * The <code>index</code> module provides access to constructors for all the classes which comprise the public API.
   * <p>
   * An AMD (recommended!) or CommonJS application will generally do something equivalent to the following:
   * <pre>
   * var FlespiGatewayRestApi = require('index'); // See note below*.
   * var xxxSvc = new FlespiGatewayRestApi.XxxApi(); // Allocate the API class we're going to use.
   * var yyyModel = new FlespiGatewayRestApi.Yyy(); // Construct a model instance.
   * yyyModel.someProperty = 'someValue';
   * ...
   * var zzz = xxxSvc.doSomething(yyyModel); // Invoke the service.
   * ...
   * </pre>
   * <em>*NOTE: For a top-level AMD script, use require(['index'], function(){...})
   * and put the application logic within the callback function.</em>
   * </p>
   * <p>
   * A non-AMD browser application (discouraged) might do something like this:
   * <pre>
   * var xxxSvc = new FlespiGatewayRestApi.XxxApi(); // Allocate the API class we're going to use.
   * var yyy = new FlespiGatewayRestApi.Yyy(); // Construct a model instance.
   * yyyModel.someProperty = 'someValue';
   * ...
   * var zzz = xxxSvc.doSomething(yyyModel); // Invoke the service.
   * ...
   * </pre>
   * </p>
   * @module index
   * @version 1.0
   */
  var exports = {
    /**
     * The ApiClient constructor.
     * @property {module:ApiClient}
     */
    ApiClient: ApiClient,
    /**
     * The Channel model constructor.
     * @property {module:model/Channel}
     */
    Channel: Channel,
    /**
     * The ChannelCommandQueue model constructor.
     * @property {module:model/ChannelCommandQueue}
     */
    ChannelCommandQueue: ChannelCommandQueue,
    /**
     * The ChannelCommandQueueChannelId model constructor.
     * @property {module:model/ChannelCommandQueueChannelId}
     */
    ChannelCommandQueueChannelId: ChannelCommandQueueChannelId,
    /**
     * The ChannelCommandQueueExpires model constructor.
     * @property {module:model/ChannelCommandQueueExpires}
     */
    ChannelCommandQueueExpires: ChannelCommandQueueExpires,
    /**
     * The ChannelCommandQueueId model constructor.
     * @property {module:model/ChannelCommandQueueId}
     */
    ChannelCommandQueueId: ChannelCommandQueueId,
    /**
     * The ChannelCommandQueueIdent model constructor.
     * @property {module:model/ChannelCommandQueueIdent}
     */
    ChannelCommandQueueIdent: ChannelCommandQueueIdent,
    /**
     * The ChannelCommandQueuePayload model constructor.
     * @property {module:model/ChannelCommandQueuePayload}
     */
    ChannelCommandQueuePayload: ChannelCommandQueuePayload,
    /**
     * The ChannelCommandQueuePut model constructor.
     * @property {module:model/ChannelCommandQueuePut}
     */
    ChannelCommandQueuePut: ChannelCommandQueuePut,
    /**
     * The ChannelCommandResult model constructor.
     * @property {module:model/ChannelCommandResult}
     */
    ChannelCommandResult: ChannelCommandResult,
    /**
     * The ChannelCommandResultExecuted model constructor.
     * @property {module:model/ChannelCommandResultExecuted}
     */
    ChannelCommandResultExecuted: ChannelCommandResultExecuted,
    /**
     * The ChannelCommandResultResponse model constructor.
     * @property {module:model/ChannelCommandResultResponse}
     */
    ChannelCommandResultResponse: ChannelCommandResultResponse,
    /**
     * The ChannelCommandsQueuePost model constructor.
     * @property {module:model/ChannelCommandsQueuePost}
     */
    ChannelCommandsQueuePost: ChannelCommandsQueuePost,
    /**
     * The ChannelConnection model constructor.
     * @property {module:model/ChannelConnection}
     */
    ChannelConnection: ChannelConnection,
    /**
     * The ChannelConnectionChannelId model constructor.
     * @property {module:model/ChannelConnectionChannelId}
     */
    ChannelConnectionChannelId: ChannelConnectionChannelId,
    /**
     * The ChannelConnectionEstablished model constructor.
     * @property {module:model/ChannelConnectionEstablished}
     */
    ChannelConnectionEstablished: ChannelConnectionEstablished,
    /**
     * The ChannelConnectionId model constructor.
     * @property {module:model/ChannelConnectionId}
     */
    ChannelConnectionId: ChannelConnectionId,
    /**
     * The ChannelConnectionIdent model constructor.
     * @property {module:model/ChannelConnectionIdent}
     */
    ChannelConnectionIdent: ChannelConnectionIdent,
    /**
     * The ChannelConnectionIp model constructor.
     * @property {module:model/ChannelConnectionIp}
     */
    ChannelConnectionIp: ChannelConnectionIp,
    /**
     * The ChannelConnectionTerminal model constructor.
     * @property {module:model/ChannelConnectionTerminal}
     */
    ChannelConnectionTerminal: ChannelConnectionTerminal,
    /**
     * The ChannelConnectionTerminalGet model constructor.
     * @property {module:model/ChannelConnectionTerminalGet}
     */
    ChannelConnectionTerminalGet: ChannelConnectionTerminalGet,
    /**
     * The ChannelEnabled model constructor.
     * @property {module:model/ChannelEnabled}
     */
    ChannelEnabled: ChannelEnabled,
    /**
     * The ChannelId model constructor.
     * @property {module:model/ChannelId}
     */
    ChannelId: ChannelId,
    /**
     * The ChannelLogmessage model constructor.
     * @property {module:model/ChannelLogmessage}
     */
    ChannelLogmessage: ChannelLogmessage,
    /**
     * The ChannelLogsPeriod model constructor.
     * @property {module:model/ChannelLogsPeriod}
     */
    ChannelLogsPeriod: ChannelLogsPeriod,
    /**
     * The ChannelMessage model constructor.
     * @property {module:model/ChannelMessage}
     */
    ChannelMessage: ChannelMessage,
    /**
     * The ChannelMessageParameter model constructor.
     * @property {module:model/ChannelMessageParameter}
     */
    ChannelMessageParameter: ChannelMessageParameter,
    /**
     * The ChannelMessageParameters model constructor.
     * @property {module:model/ChannelMessageParameters}
     */
    ChannelMessageParameters: ChannelMessageParameters,
    /**
     * The ChannelName model constructor.
     * @property {module:model/ChannelName}
     */
    ChannelName: ChannelName,
    /**
     * The ChannelPost model constructor.
     * @property {module:model/ChannelPost}
     */
    ChannelPost: ChannelPost,
    /**
     * The ChannelProtocolId model constructor.
     * @property {module:model/ChannelProtocolId}
     */
    ChannelProtocolId: ChannelProtocolId,
    /**
     * The ChannelProtocolName model constructor.
     * @property {module:model/ChannelProtocolName}
     */
    ChannelProtocolName: ChannelProtocolName,
    /**
     * The ChannelPut model constructor.
     * @property {module:model/ChannelPut}
     */
    ChannelPut: ChannelPut,
    /**
     * The ChannelUri model constructor.
     * @property {module:model/ChannelUri}
     */
    ChannelUri: ChannelUri,
    /**
     * The Channels model constructor.
     * @property {module:model/Channels}
     */
    Channels: Channels,
    /**
     * The ChannelsId model constructor.
     * @property {module:model/ChannelsId}
     */
    ChannelsId: ChannelsId,
    /**
     * The Data model constructor.
     * @property {module:model/Data}
     */
    Data: Data,
    /**
     * The Data1 model constructor.
     * @property {module:model/Data1}
     */
    Data1: Data1,
    /**
     * The Error model constructor.
     * @property {module:model/Error}
     */
    Error: Error,
    /**
     * The InlineResponse200 model constructor.
     * @property {module:model/InlineResponse200}
     */
    InlineResponse200: InlineResponse200,
    /**
     * The InlineResponse2001 model constructor.
     * @property {module:model/InlineResponse2001}
     */
    InlineResponse2001: InlineResponse2001,
    /**
     * The InlineResponse2002 model constructor.
     * @property {module:model/InlineResponse2002}
     */
    InlineResponse2002: InlineResponse2002,
    /**
     * The InlineResponse2003 model constructor.
     * @property {module:model/InlineResponse2003}
     */
    InlineResponse2003: InlineResponse2003,
    /**
     * The InlineResponse2004 model constructor.
     * @property {module:model/InlineResponse2004}
     */
    InlineResponse2004: InlineResponse2004,
    /**
     * The InlineResponse2005 model constructor.
     * @property {module:model/InlineResponse2005}
     */
    InlineResponse2005: InlineResponse2005,
    /**
     * The InlineResponse2006 model constructor.
     * @property {module:model/InlineResponse2006}
     */
    InlineResponse2006: InlineResponse2006,
    /**
     * The InlineResponse2007 model constructor.
     * @property {module:model/InlineResponse2007}
     */
    InlineResponse2007: InlineResponse2007,
    /**
     * The InlineResponse2008 model constructor.
     * @property {module:model/InlineResponse2008}
     */
    InlineResponse2008: InlineResponse2008,
    /**
     * The InlineResponse2009 model constructor.
     * @property {module:model/InlineResponse2009}
     */
    InlineResponse2009: InlineResponse2009,
    /**
     * The Protocol model constructor.
     * @property {module:model/Protocol}
     */
    Protocol: Protocol,
    /**
     * The ProtocolDescription model constructor.
     * @property {module:model/ProtocolDescription}
     */
    ProtocolDescription: ProtocolDescription,
    /**
     * The ProtocolId model constructor.
     * @property {module:model/ProtocolId}
     */
    ProtocolId: ProtocolId,
    /**
     * The ProtocolName model constructor.
     * @property {module:model/ProtocolName}
     */
    ProtocolName: ProtocolName,
    /**
     * The ChannelsApi service constructor.
     * @property {module:api/ChannelsApi}
     */
    ChannelsApi: ChannelsApi,
    /**
     * The CommandsqueueApi service constructor.
     * @property {module:api/CommandsqueueApi}
     */
    CommandsqueueApi: CommandsqueueApi,
    /**
     * The CommandsresultApi service constructor.
     * @property {module:api/CommandsresultApi}
     */
    CommandsresultApi: CommandsresultApi,
    /**
     * The ConnectionsApi service constructor.
     * @property {module:api/ConnectionsApi}
     */
    ConnectionsApi: ConnectionsApi,
    /**
     * The ConnectionsterminalApi service constructor.
     * @property {module:api/ConnectionsterminalApi}
     */
    ConnectionsterminalApi: ConnectionsterminalApi,
    /**
     * The LogsApi service constructor.
     * @property {module:api/LogsApi}
     */
    LogsApi: LogsApi,
    /**
     * The MessagesApi service constructor.
     * @property {module:api/MessagesApi}
     */
    MessagesApi: MessagesApi,
    /**
     * The ProtocolsApi service constructor.
     * @property {module:api/ProtocolsApi}
     */
    ProtocolsApi: ProtocolsApi
  };

  return exports;
}));
