/**
 * flespi gateway REST API 
 * **DISCLAIMER**: This is a beta version of the flespi gateway API, in the process of being tested before its official release on 31 May, 2017. Being so, there is no guarantee that system architecture will not change until release date.  This API provides methods to set up and manage data flow channels from tracking devices to [flespi gateway](https://flespi.com/gateway) and further to your application. While raw data from devices comes in unparsed and fragmented way, flespi gateway takes on work to analyze incoming data from different types of hardware, registers it to unified-formatted messages and provides easy and reliable access to tracker's data for your software. Note that access to messages from trackers is provided in a **single reader** way, i.e. stable reading can be carried out by only one worker.  To perform operations above you need to specify FlespiToken key provided on entrance to your personal account (this key is to be passed in REST API call via header: **Authorization: FlespiToken XXXXXXXXXX**).  Detailed REST API description provided in [guidelines](https://flespi.com/api-guidelines). 
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD.
    define(['expect.js', '../../src/index'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    factory(require('expect.js'), require('../../src/index'));
  } else {
    // Browser globals (root is window)
    factory(root.expect, root.FlespiGatewayRestApi);
  }
}(this, function(expect, FlespiGatewayRestApi) {
  'use strict';

  var instance;

  beforeEach(function() {
    instance = new FlespiGatewayRestApi.ChannelLogmessage();
  });

  var getProperty = function(object, getter, property) {
    // Use getter method if present; otherwise, get the property directly.
    if (typeof object[getter] === 'function')
      return object[getter]();
    else
      return object[property];
  }

  var setProperty = function(object, setter, property, value) {
    // Use setter method if present; otherwise, set the property directly.
    if (typeof object[setter] === 'function')
      object[setter](value);
    else
      object[property] = value;
  }

  describe('ChannelLogmessage', function() {
    it('should create an instance of ChannelLogmessage', function() {
      // uncomment below and update the code to test ChannelLogmessage
      //var instane = new FlespiGatewayRestApi.ChannelLogmessage();
      //expect(instance).to.be.a(FlespiGatewayRestApi.ChannelLogmessage);
    });

    it('should have the property channelId (base name: "channel_id")', function() {
      // uncomment below and update the code to test the property channelId
      //var instane = new FlespiGatewayRestApi.ChannelLogmessage();
      //expect(instance).to.be();
    });

    it('should have the property event (base name: "event")', function() {
      // uncomment below and update the code to test the property event
      //var instane = new FlespiGatewayRestApi.ChannelLogmessage();
      //expect(instance).to.be();
    });

    it('should have the property source (base name: "source")', function() {
      // uncomment below and update the code to test the property source
      //var instane = new FlespiGatewayRestApi.ChannelLogmessage();
      //expect(instance).to.be();
    });

    it('should have the property ident (base name: "ident")', function() {
      // uncomment below and update the code to test the property ident
      //var instane = new FlespiGatewayRestApi.ChannelLogmessage();
      //expect(instance).to.be();
    });

    it('should have the property duration (base name: "duration")', function() {
      // uncomment below and update the code to test the property duration
      //var instane = new FlespiGatewayRestApi.ChannelLogmessage();
      //expect(instance).to.be();
    });

    it('should have the property msgs (base name: "msgs")', function() {
      // uncomment below and update the code to test the property msgs
      //var instane = new FlespiGatewayRestApi.ChannelLogmessage();
      //expect(instance).to.be();
    });

    it('should have the property recv (base name: "recv")', function() {
      // uncomment below and update the code to test the property recv
      //var instane = new FlespiGatewayRestApi.ChannelLogmessage();
      //expect(instance).to.be();
    });

    it('should have the property send (base name: "send")', function() {
      // uncomment below and update the code to test the property send
      //var instane = new FlespiGatewayRestApi.ChannelLogmessage();
      //expect(instance).to.be();
    });

    it('should have the property commandId (base name: "command_id")', function() {
      // uncomment below and update the code to test the property commandId
      //var instane = new FlespiGatewayRestApi.ChannelLogmessage();
      //expect(instance).to.be();
    });

    it('should have the property commandPayload (base name: "command_payload")', function() {
      // uncomment below and update the code to test the property commandPayload
      //var instane = new FlespiGatewayRestApi.ChannelLogmessage();
      //expect(instance).to.be();
    });

  });

}));
